# Appyx


Model-driven navigation for Jetpack Compose

[https://github.com/bumble-tech/appyx](https://github.com/bumble-tech/appyx)


## Navigation for your Compose app on steroids

- **Navigate directly from code** – In a type-safe way, without boilerplate
- **Gain control of navigation state** – Making your navigation unit-testable
- **Complete control over operations and behaviour** – Use and extend the back stack or the view pager from the library, or build your own 
- **Use any animation for transitions** – Anything you can represent with Compose `Modifiers`


## Model-driven navigation – a different paradigm with superpowers

Using Appyx you gain navigation superpowers in addition to screen-to-screen navigation:  

- **Break down screen boundaries** – Using Routing sources you can navigate inside the screen as well as between them
- **Make your navigation composable** – Navigate whole scopes of your application 

Using a model-driven approach, navigation states are yours to define – Appyx makes it happen with any animation you can represent using Compose `Modifiers`. Back stacks, card stacks, view pagers are just the beginning:

<img src="https://i.imgur.com/8gy3Ghb.gif" width="150"> <img src="https://i.imgur.com/Kj0P85H.gif" width="150"> <img src="https://i.imgur.com/N8rEPrJ.gif" width="150"> <img src="https://i.imgur.com/esLXh61.gif" width="150">


You can create custom navigable components in no time:

<img src="https://i.imgur.com/V3bks8c.gif" width="150">


With Appyx you can break down screen boundaries and transform the screen itself:

<img src="https://i.imgur.com/pbDENSc.gif" width="150">


## Launch the demo app

Check out the project and launch the `:app` module for a quick demonstration


## Download

See the [Downloads page](releases/downloads.md).


## Articles

1. [Appyx is released! (1.0-alpha02)](https://medium.com/bumble-tech/appyx-is-released-1-0-alpha02-41a27ad3b0cd)
2. [Appyx vs Jetpack Compose Navigation](https://medium.com/bumble-tech/appyx-vs-jetpack-compose-navigation-b91bd23369f2)
